Subject: circuit-level pacing

From: [email-masked]
Date: Fri, 22 Oct 93 10:34:58 EDT

I agree with most of the points raised in recent appends, that fixed
pacing would be a more appropriate base flow control mechanism than
using a stop/start message.  Here are some additional thoughts:

(1) On the possibility of no base flow control mechanism
Jim Cobban wrote:
> The current 6611 does not implement any connection level flow control, and
> it is arguably a successful product despite that.  I am therefore not
> convinced that there is a requirement to include a flow control mechanism in
> the base capability set for DLSw.

I think this may be a dangerous inference to make.  Since the 6611 soft-
ware is based on AIX, it uses a virtual memory model supporting by real
paging.  It therefore has more buffering capability than most routers,
which do not have this sort of system structure.  I think we should
select our base to support the "typical" DLSw router, which I presume
would have stricter memory limitations than the 6611.

(2) On the complexity of adaptive pacing
If we end up with some derivative of APPN adaptive pacing (I don't have
news to report on the patent issue yet), we should recognize two facts:
  - fixed pacing can use exactly the same frame formats as adaptive pacing
  - almost all the adaptive pacing complexity is in the receiver, as it
    manages its buffers and determines how to adjust window size to
    respond to current conditions.  The sender's algorithm is very simple
    and can be the same whether the receiver is operating in a fixed or
    adaptive mode.
It may therefore be possible to say that the base is to support a simple
sender algorithm and these common frame formats, and leave it up to each
product how complicated a receiver algorithm they want to build.  If we
took this approach, we would not need an "adaptive pacing" capability
exchanged and agreed to by both partners.  The base would include the
ability to send to either a fixed or adaptive pacing partner.

Peter